open Ast

let import_decl = "
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.color.ColorSpace;
import java.awt.image.BufferedImage;
import java.awt.image.ColorConvertOp;
import java.awt.image.ColorModel;
import java.awt.image.ConvolveOp;
import java.awt.image.Kernel;
import java.awt.image.WritableRaster;
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.lang.RuntimeException;
import java.util.Hashtable;
import javax.imageio.ImageIO;
import javax.swing.JFrame;
import javax.swing.JPanel;

"

let class_decl = "public class Matlip {\n" ^ 
                 "enum OPERATION { ADD, SUB, MUL, DIV }" ^
                 "\n" ^
                 "   static BufferedImage imread(String path){\n" ^ 
                 "      try{\n" ^
                 "         BufferedImage  image;\n" ^
                 "         image = ImageIO.read(new File(path));\n" ^
                 "         return image;\n" ^
                 "      }\n" ^
                 "      catch (IOException e){\n" ^ 
                 "         System.out.println(\"Error:\"+e.getMessage());\n" ^
                 "         return null;\n" ^
                 "      }\n" ^
                 "   }\n" ^
                 "\n" ^
                 "   static void imshow(BufferedImage im){\n" ^
                 "\n" ^
                 "      try {\n" ^ 
                 "         ImageRenderComponent irc = new ImageRenderComponent(im);\n" ^
                 "         irc.setOpaque(true);\n" ^
                 "         JFrame f = new JFrame(\"Display Image\");\n" ^
                 "         f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);\n" ^
                 "         f.setContentPane(irc);\n" ^
                 "         f.setSize(800,600);\n" ^
                 "         f.setVisible(true);\n" ^ 
                 "      }\n" ^
                 "      catch (Exception e){\n" ^
                 "         e.printStackTrace();\n" ^
                 "      }\n" ^
                 "   }\n" ^
                 "\n" ^
                 "   /*\n" ^
                 "    * the image formats supported by JRE are\n" ^
                 "    * BMP, bmp\n" ^
                 "      jpg, JPG\n" ^
                 "      wbm\n" ^
                 "      jpeg\n" ^
                 "      png, PNG\n" ^
                 "      JPEG\n" ^
                 "      WBMP\n" ^
                 "      GIF, gif\n" ^
                 "    */\n" ^
                 "   static void imsave(BufferedImage im,String path){\n" ^
                 "      try {\n" ^
                 "         File outputfile = new File(path);\n" ^
                 "         String format = path.substring(path.lastIndexOf(\".\")+1, path.length());\n" ^
                 "         ImageIO.write(im, format, outputfile);\n" ^
                 "      }\n" ^
                 "      catch (IOException e) {\n" ^
                 "         System.out.println(\"Error:\"+e.getMessage());\n" ^
                 "      }\n" ^
                 "   }\n" ^
                 "\n" ^ "
    static BufferedImage imnew(int width, int height, String type){
        BufferedImage im=null;
        
        if (type.contentEquals(\"RGB\")){
            im = new BufferedImage(width, height, BufferedImage.TYPE_3BYTE_BGR);
            for (int i=0;i<im.getHeight();i++){
                for (int j=0;j<im.getWidth();j++){
                    im.setRGB(j, i, 0xFF000000);
                }
            }
            
        }
        else if (type.contentEquals(\"GREY\") || type.contentEquals(\"GRAY\")){
            im = new BufferedImage(width, height, BufferedImage.TYPE_BYTE_GRAY);
        }
        
        return im;
    }
                 " ^
                 "\n" ^ 
                 "
    static Kernel kernelinit(){
        Kernel k = new Kernel(3,3,new float[] {
                    0.0f, 0.0f, 0.0f,
                    0.0f, 1.0f, 0.0f,
                    0.0f, 0.0f, 0.0f
                });
        return k;
    }

    static Kernel kernelnew(int width, int height){

        try{
            float[] data = new float[width*height];
            Kernel k = new Kernel(width, height, data);
            return k;
        }
        catch (Exception e){
            e.printStackTrace();
            return null;
        }
    }
                 " ^
                 "\n" ^
                 "   static void print(Object data){\n" ^
                 "      System.out.print(data);\n" ^
                 "   }\n" ^
                 "\n" ^
                 "   static int getWidth(BufferedImage im){\n" ^
                 "      try {\n" ^
                 "         return im.getWidth();\n" ^
                 "      }\n" ^
                 "      catch (Exception e){\n" ^
                 "         e.printStackTrace();\n" ^
                 "         return -1;\n" ^
                 "      }\n" ^
                 "   }\n" ^
                 "\n" ^
                 "   static int getWidth(Kernel k){\n" ^
                 "      try {\n" ^
                 "         return k.getWidth();\n" ^
                 "      }\n" ^
                 "      catch (Exception e){\n" ^
                 "         e.printStackTrace();\n" ^
                 "         return -1;\n" ^
                 "      }\n" ^
                 "   }\n" ^
                 "\n" ^
                 "   static int getHeight(BufferedImage im){\n" ^
                 "      try {\n" ^
                 "         return im.getHeight();\n" ^
                 "      }\n" ^
                 "      catch (Exception e){\n" ^
                 "         e.printStackTrace();\n" ^
                 "         return -1;\n" ^
                 "      }\n" ^
                 "   }\n" ^
                 "\n" ^
                 "   static int getHeight(Kernel k){\n" ^
                 "      try {\n" ^
                 "         return k.getHeight();\n" ^
                 "      }\n" ^
                 "      catch (Exception e){\n" ^
                 "         e.printStackTrace();\n" ^
                 "         return -1;\n" ^
                 "      }\n" ^
                 "   }\n" ^
                 "\n" ^ "
    static String getType(BufferedImage im){
        
        try{
            if (im.getType() == BufferedImage.TYPE_INT_ARGB || im.getType() == BufferedImage.TYPE_3BYTE_BGR || im.getType() == BufferedImage.TYPE_BYTE_INDEXED){
                return \"RGB\";
            }        
            else if (im.getType() == BufferedImage.TYPE_BYTE_GRAY) {
                return \"GREY\";
            }
            else {
                return \"unknown type\";
            }
        }
        catch (Exception e){
            e.printStackTrace();
            return \"ERROR: getType()\";
        }
    }
                 " ^
                 "\n" ^
                 "   static int getLength(String s){\n" ^
                 "      try {\n" ^
                 "         return s.length();\n" ^
                 "      }\n" ^
                 "      catch (Exception e){\n" ^
                 "         e.printStackTrace();\n" ^
                 "         return -1;\n" ^
                 "      }\n" ^
                 "   }\n" ^
                 "\n" ^
                 "
    static float getKernelData(Kernel k,int i, int j){
        float[] data = new float[k.getHeight()*k.getWidth()];
        k.getKernelData(data);

        return data[i+j*k.getWidth()];

    }

    static Kernel setKernelData(Kernel k, int i, int j, float value){
        float[] data = new float[k.getHeight()*k.getWidth()];
        k.getKernelData(data);
        data[i+j*k.getWidth()] = value;
        k = new Kernel(k.getWidth(),k.getHeight(),data);
        return k;
    }

   private static int objectToInt(Object o){
       if (o.getClass().getName().contentEquals(\"java.lang.Float\")){
           return (int)Float.parseFloat(o.toString());
       }
       else if (o.getClass().getName().contentEquals(\"java.lang.Double\")){
           return (int)Double.parseDouble(o.toString());
       }
       else if (o.getClass().getName().contentEquals(\"java.lang.Integer\")){
           return Integer.parseInt(o.toString());
       }
       else if (o.getClass().getName().contentEquals(\"java.lang.String\")){
           return Integer.parseInt(o.toString());
       }
       else {
           throw new RuntimeException(\"type error!\");
       }
       
   }
   
   private static float objectToFloat(Object o){
       if (o.getClass().getName().contentEquals(\"java.lang.Float\")){
           return Float.parseFloat(o.toString());
       }
       else if (o.getClass().getName().contentEquals(\"java.lang.Double\")){
           return (float)Double.parseDouble(o.toString());
       }
       else if (o.getClass().getName().contentEquals(\"java.lang.Integer\")){
           return (float)Integer.parseInt(o.toString());
       }
       else if (o.getClass().getName().contentEquals(\"java.lang.String\")){
           return Float.parseFloat(o.toString());
       }
       else {
           throw new RuntimeException(\"type error!\");
       }
   }

    static Object doArithmetic(Object op1, Object op2, OPERATION op){

            if (op1 instanceof BufferedImage){
                BufferedImage des;
                boolean color=false;
                try{
                    int t = ((BufferedImage)op1).getSampleModel().getSample(0, 0, 1, ((BufferedImage)op1).getRaster().getDataBuffer());
                    //des = imnew(((BufferedImage)op1).getWidth(),((BufferedImage)op1).getHeight(),\"RGB\");
                    des = new BufferedImage(((BufferedImage)op1).getWidth(),((BufferedImage)op1).getHeight(),((BufferedImage)op1).getType());
                    color=true;
                } catch (Exception e){
                    des = imnew(((BufferedImage)op1).getWidth(),((BufferedImage)op1).getHeight(),\"GREY\");
                }
                        
                if (op2 instanceof BufferedImage){
                    if (((BufferedImage)op1).getHeight()!=((BufferedImage)op2).getHeight() || ((BufferedImage)op1).getWidth()!=((BufferedImage)op2).getWidth())
                        throw new RuntimeException(\"dimension mismatch!\");                                            
                }
                    
                       

                int v1;
                int v2;
                for (int j=0;j<((BufferedImage)des).getHeight();j++){
                    for (int i=0;i<((BufferedImage)des).getWidth();i++){
                        if (color){
                            v1 = ((BufferedImage)op1).getRGB(i, j);
                            if (op2 instanceof BufferedImage)
                                v2 = ((BufferedImage)op2).getRGB(i, j);
                            else 
                                v2 = objectToInt(op2);
                            
                                
                        }
                        else{
                            v1 = ((BufferedImage)op1).getSampleModel().getSample(i,j,0,((BufferedImage)op1).getRaster().getDataBuffer());
                            if (op2 instanceof BufferedImage)
                                v2 = ((BufferedImage)op2).getSampleModel().getSample(i,j,0,((BufferedImage)op2).getRaster().getDataBuffer());
                            else 
                                v2 = objectToInt(op2);
                        }

                        switch (op){
                            case ADD:
                                if (color){
                                    ((BufferedImage)des).setRGB(i, j, (int)v1+v2);
                                    break;
                                }
                                else{
                                    ((BufferedImage)des).getSampleModel().setSample(i, j, 0,(int)v1+v2 , ((BufferedImage)des).getRaster().getDataBuffer());
                                    break;
                                }
                            case SUB:
                               if (color){
                                    ((BufferedImage)des).setRGB(i, j, (int)v1-v2);                                    
                                    break;
                                }
                                else{
                                    ((BufferedImage)des).getSampleModel().setSample(i, j, 0,(int)v1-v2 , ((BufferedImage)des).getRaster().getDataBuffer());
                                    break;
                                }
                            case MUL:
                                if (color){
                                    ((BufferedImage)des).setRGB(i, j, (int)v1*v2);
                                    break;
                                }
                                else{
                                    ((BufferedImage)des).getSampleModel().setSample(i, j, 0,(int)v1*v2 , ((BufferedImage)des).getRaster().getDataBuffer());
                                    break;
                                }
                            case DIV:
                               if (color){
                                    ((BufferedImage)des).setRGB(i, j, (int)v1/v2);
                                    break;
                                }
                                else{
                                    ((BufferedImage)des).getSampleModel().setSample(i, j, 0,(int)v1/v2 , ((BufferedImage)des).getRaster().getDataBuffer());
                                    break;
                                }
                        }
//                        if (!((BufferedImage)des).isAlphaPremultiplied())
//                        ((BufferedImage)des).getSampleModel().setSample(i, j, 3,0xFF , ((BufferedImage)des).getRaster().getDataBuffer());
                    }
                } // end of for 
                return des;                
            }      
            
            else if (op1 instanceof Kernel){
                float[] des = new float[((Kernel)op1).getWidth()*((Kernel)op1).getHeight()];
                float[] data1 = new float[((Kernel)op1).getWidth()*((Kernel)op1).getHeight()];
                ((Kernel)op1).getKernelData(data1);
                
                float[] data2 = new float[((Kernel)op1).getWidth()*((Kernel)op1).getHeight()];
                
                if (op2 instanceof Kernel){
                    if (((Kernel)op1).getHeight()!=((Kernel)op2).getHeight() || ((Kernel)op1).getWidth()!=((Kernel)op2).getWidth())
                        throw new RuntimeException(\"dimension mismatch!\");                                            
                    
                    
                    ((Kernel)op2).getKernelData(data2);
                }
                
                
                float v1;
                float v2;
                
                for (int i=0;i<des.length;i++){
                    v1 = data1[i];
                    if (op2 instanceof Kernel)
                        v2 = data2[i];
                    else 
                        v2 = objectToFloat(op2);
                    
                      switch (op){
                            case ADD:
                               des[i] = v1+v2;
                               break;
                            case SUB:
                                des[i] = v1-v2;
                                break;
                            case MUL:
                                  des[i] = v1*v2;
                                  break;
                            case DIV:
                              des[i] = v1/v2;
                               break;
                        }
                }
              
                return new Kernel(((Kernel)op1).getWidth(),((Kernel)op1).getHeight(),des);
            }
            else{
                throw new RuntimeException(\"op1 type error!\");        
            }
    }


    static Object clone(Object src){
        if (src instanceof BufferedImage){
             String[] pnames = ((BufferedImage)src).getPropertyNames();
             Hashtable<String, Object> cproperties = new Hashtable<String,Object>();
             if(pnames != null) {
               for(int i = 0; i < pnames.length; i++) {
                   cproperties.put(pnames[i], ((BufferedImage)src).getProperty(pnames[i]));
               }
            }
            WritableRaster wr = ((BufferedImage)src).getRaster();
            WritableRaster cwr = wr.createCompatibleWritableRaster();
            cwr.setRect(wr);
            BufferedImage des = new BufferedImage(
               ((BufferedImage)src).getColorModel(),  // should be immutable
               cwr,
               ((BufferedImage)src).isAlphaPremultiplied(),
               cproperties);

            return des;
        }
        else if (src instanceof Kernel){
            return ((Kernel)src).clone();
        }
        else{
            throw new RuntimeException(\"the type of source is not cloneable!\");
        }
    }

    static String read(){
        try{
            return (new BufferedReader(new InputStreamReader(System.in))).readLine();
        }
        catch(Exception e){
            e.printStackTrace();
            return null;
        }
    }

    static void setImagePixel(BufferedImage im, int col, int row, String channel, int value){
        try{
            if (channel.toUpperCase().contentEquals(\"RGB\")){
                    im.setRGB(col, row, value|0xFF000000);
            }
            else if (channel.toUpperCase().contentEquals(\"R\")){
                    im.getSampleModel().setSample(col, row, 0, value, im.getRaster().getDataBuffer());
            }
            else if (channel.toUpperCase().contentEquals(\"G\")){
                    im.getSampleModel().setSample(col, row, 1, value, im.getRaster().getDataBuffer());
            }
            else if (channel.toUpperCase().contentEquals(\"B\")){
                    im.getSampleModel().setSample(col, row, 2, value, im.getRaster().getDataBuffer());
            }
            else if (channel.toUpperCase().contentEquals(\"GREY\") || channel.toUpperCase().contentEquals(\"GRAY\")){
                    im.getSampleModel().setSample(col, row, 0, value, im.getRaster().getDataBuffer());
            }
            else{
                throw new RuntimeException(\"invalid channnel!\");
            }
        }
        catch (Exception e){
            e.printStackTrace();
            System.exit(1);
        }
    }

    static int getImagePixel(BufferedImage im, int col, int row, String channel){
        int ret;
        try{
            if (channel.toUpperCase().contentEquals(\"RGB\")){
                ret = im.getRGB(col, row)&0x00FFFFFF;
            }
            else if (channel.toUpperCase().contentEquals(\"R\")){
                    ret = im.getSampleModel().getSample(col, row, 0, im.getRaster().getDataBuffer());
            }
            else if (channel.toUpperCase().contentEquals(\"G\")){
                    ret = im.getSampleModel().getSample(col, row, 1, im.getRaster().getDataBuffer());
            }
            else if (channel.toUpperCase().contentEquals(\"B\")){
                    ret = im.getSampleModel().getSample(col, row, 2, im.getRaster().getDataBuffer());
            }
            else if (channel.toUpperCase().contentEquals(\"GREY\") || channel.toUpperCase().contentEquals(\"GRAY\")){
                    ret = im.getSampleModel().getSample(col, row, 0, im.getRaster().getDataBuffer());
            }
            else{
                throw new RuntimeException(\"invalid channnel!\");
            }
        }
        catch(Exception e){
            e.printStackTrace();
            System.exit(1);
        }
        finally {
            return ret;
        }
    }

    static BufferedImage convolve(BufferedImage im, Kernel k){
        BufferedImage imc = new BufferedImage(im.getWidth(), im.getHeight(), im.getType());
        ConvolveOp convo = new ConvolveOp(k);
        convo.filter(im, imc);
        return imc;
    }
                 "

(* initialize all variables *)
let initial_value vtype =
  if vtype = "void" then ""
  else if vtype = "int" then "0"
  else if vtype = "float" then "(float)0.0"
  else if vtype = "string" then "\"\""
  else if vtype = "boolean" then "false"
  else if vtype = "image" then "imnew(100, 100, \"RGB\")"
  else if vtype = "kernel" then "kernelinit()"
  else
    raise (Failure ("unrecognized type: " ^ vtype))

(* convert MATLIP data type to Java data type *)
let java_type_of vtype =
  if vtype = "void" then "void"
  else if vtype = "int" then "int"
  else if vtype = "float" then "float"
  else if vtype = "string" then "String"
  else if vtype = "boolean" then "boolean"
  else if vtype = "image" then "BufferedImage"
  else if vtype = "kernel" then "Kernel"
  else
    raise (Failure ("unrecognized type: " ^ vtype))

let fsignature fdecl =
  if fdecl.fname = "main" then "public static void main(String[] args)"
  (* else "public static int " ^ fdecl.fname ^ "(int " ^ String.concat ", int " fdecl.formals ^ ")" *)
  else
    let formal_string_list = List.fold_left (fun f_list formal -> (java_type_of formal.vartype ^ " " ^ formal.varname)::f_list) [] fdecl.formals
    in
    "public static " ^ java_type_of fdecl.rettype ^ " " ^ fdecl.fname ^ "(" ^ String.concat "," (List.rev formal_string_list) ^ ")"

let imgrender_decl = "class ImageRenderComponent extends JPanel {\n" ^
                     "   BufferedImage image;\n" ^
                     "   Dimension size;\n" ^
                     "\n" ^
                     "   public ImageRenderComponent(BufferedImage image) {\n" ^
                     "      this.image = image;\n" ^
                     "      size = new Dimension(image.getWidth(), image.getHeight());\n" ^
                     "   }\n" ^
                     "\n" ^
                     "   @Override\n" ^
                     "   protected void paintComponent(Graphics g) {\n" ^
                     "      super.paintComponent(g);\n" ^
                     "      int x = (getWidth() - size.width)/2;\n" ^
                     "      int y = (getHeight() - size.height)/2;\n" ^
                     "      g.drawImage(image, x, y, this);\n" ^
                     "   }\n" ^
                     "\n" ^
                     "   @Override\n" ^
                     "   public Dimension getPreferredSize() {\n" ^
                     "      return size;\n" ^
                     "   }\n" ^
                     "}\n"

let fcall f =
  if f = "print" then "System.out.println"
  else if f = "imread" then "imread"
  else if f = "imsave" then "imsave"
  else if f = "imshow" then "imshow"
  else if f = "kernelnew" then "kernelnew"
  else if f = "getwidth" then "getWidth"
  else if f = "getheight" then "getHeight"
  else if f = "getlength" then "getLength"
  else if f = "gettype" then "getType"
  else if f = "toint" then "objectToInt"
  else if f = "tofloat" then "objectToFloat"
  else if f = "read" then "read"
  else f

(* build a list of 'num' elements of name *)
let rec build_list (name, num, l) =
  if num = 0 then l
  else build_list (name, num-1, name::l)

(* determine channel number *)
let channel_num s =
  if s = "R" || s = "r" then "0"
  else if s = "G" || s = "g" then "1"
  else if s = "B" || s = "b" then "2"
  else raise (Failure ("Unrecognized channel: must be one of \"R\", \"G\", \"B\", \"RGB\""))

(* returns the type of an expression, mainly for images, kernels, and power operator *)
let rec type_of_expr symbols = function
    Literal(l) -> { varname = string_of_int l; vartype = "int" }
  | Floatlit(f) -> { varname = string_of_float f; vartype = "float" }
  | String(s) -> { varname = s; vartype = "string" }
  | Bool(s) -> { varname = s; vartype = "boolean" } 
  | Id(s) ->
      (* try to find it in local table first *)
      let exists = List.exists (fun a -> if a.varname = s then true else false) symbols
      in
      if exists then
        let var = List.find (fun a -> if a.varname = s then true else false) symbols
        in
        var
      else (* then try to find it in global table *)
        let exists2 = List.exists (fun a -> if a.varname = s ^ "_global_var" then true else false) symbols
        in
        if exists2 then
          let var = List.find (fun a -> if a.varname = s ^ "_global_var" then true else false) symbols
          in
          { varname = s; vartype = var.vartype }
        else
          raise (Failure ("Unable to find " ^ s ^ " in symbol table"))
      (**
      let var_list = List.find_all (fun a -> if a.varname = s then true else false) symbols
      in
      if List.length var_list > 1 then
        raise (Failure ("Functions and variables cannot share the same name: '" ^ s ^ "'"))
      else
        List.hd var_list
      **)
  | Uminus(e) ->
      let ue = type_of_expr symbols e
      in ue
  | Not(e) ->
      let ne = type_of_expr symbols e
      in ne
  | Binop(e1, o, e2) -> begin
      match o with
        Equal | Neq | Less | Leq | Greater | Geq ->
        { varname = "null"; vartype = "boolean" }
      | _ -> (* The rest of expr have the same type as the first operand *)
        let e = type_of_expr symbols e1
        in e
    end
  | Imnew(row, col, format) -> { varname = "imnew"; vartype = "image" }
  | Kernelnew(row, col) -> { varname = "kernelnew";vartype = "kernel" }
  | Assign(v, e) ->
      (* try to find it in local table first *)
      let exists = List.exists (fun a -> if a.varname = v then true else false) symbols
      in
      if exists then
        let var = List.find (fun a -> if a.varname = v then true else false) symbols
        in
        var
      else (* then try to find it in global table *)
        let exists2 = List.exists (fun a -> if a.varname = v ^ "_global_var" then true else false) symbols
        in
        if exists2 then
          let var = List.find (fun a -> if a.varname = v ^ "_global_var" then true else false) symbols
          in
          { varname = v; vartype = var.vartype }
        else
          raise (Failure ("Unable to find " ^ v ^ " in symbol table"))      
      (**
      let var_list = List.find_all (fun a -> if a.varname = v then true else false) symbols
      in
      if List.length var_list > 1 then
        raise (Failure ("Functions and variables cannot share the same name: '" ^ v ^ "'"))
      else
        List.hd var_list
      **)
  | AssignPixel(id, row, col, channel, value) -> { varname = "null"; vartype = "int" }
  | AssignKernel(id, row, col, value) -> { varname = "null";vartype = "float" }
  | ImageAccess(id, row, col, channel) -> { varname = "null"; vartype = "int" }
  | KernelAccess(id, row, col) -> { varname = "null";vartype = "float" }
  | Call(f, el) ->
      let exists = List.exists (fun a -> if a.varname = f ^ "_global_func" then true else false) symbols
      in
      if exists then (* if f is in our symbole table *)
        let ff = List.find (fun a -> if a.varname = f ^ "_global_func" then true else false) symbols
        in
        { varname = f; vartype = ff.vartype }
        (**
        let ff_list = List.find_all (fun a -> if a.varname = f then true else false) symbols
        in
        if List.length ff_list > 1 then
          raise (Failure ("Functions and variables cannot share the same name: '" ^ f ^ "'"))
        else
          let ff = List.hd ff_list in
          { varname = ff.varname; vartype = ff.vartype }
        **)
      else if f = "imread" then
        { varname = "imread"; vartype = "image" }
      else if f = "imnew" then
        { varname = "imnew"; vartype = "image" }
      else if f = "kernelnew" then
        { varname = "kernelnew"; vartype = "kernel" }
      else if f = "getwidth" then
        { varname = "getwidth"; vartype = "int" }
      else if f = "getheight" then
        { varname = "getheight"; vartype = "int" }
      else if f = "getlength" then
        { varname = "getlength"; vartype = "int" }
      else if f = "gettype" then
        { varname = "gettype"; vartype = "string" }
      else if f = "toint" then
        { varname = "toint"; vartype = "int" }
      else if f = "tofloat" then
        { varname = "tofloat"; vartype = "float" }
      else if f = "tostring" then
        { varname = "tostring"; vartype = "string" }
      else if f = "togray" then
        { varname = "togray"; vartype = "image" }
      else if f = "read" then
        { varname = "read"; vartype = "string" }
      else if f = "mod" then
        let first_arg = List.hd el
        in
        let e = type_of_expr symbols first_arg
        in
        if e.vartype = "int" then
          { varname = "mod"; vartype = "int" }
        else if e.vartype = "float" then
          { varname = "mod"; vartype = "float" }
        else (* walker should block this*)
          { varname = ""; vartype = "" }
      else if f = "sqrt" then
        let arg = List.hd el
        in
        let e = type_of_expr symbols arg
        in
        if e.vartype = "int" then
          { varname = "sqrt"; vartype = "int" }
        else if e.vartype = "float" then
          { varname = "sqrt"; vartype = "float" }
        else (* walker should block this*)
          { varname = ""; vartype = "" }
      else
        { varname = ""; vartype = "" }
  | _ -> { varname = ""; vartype = "" }

(* given variable v, find it in symbol table *)
let rec find_symbol symbols v =
  (* try to find it in local table first *)
  let exists = List.exists (fun a -> if a.varname = v then true else false) symbols
  in
  if exists then
    let var = List.find (fun a -> if a.varname = v then true else false) symbols
    in
    var
  else (* then try to find it in global table *)
    let exists2 = List.exists (fun a -> if a.varname = v ^ "_global_var" then true else false) symbols
    in
    if exists2 then
      let var = List.find (fun a -> if a.varname = v ^ "_global_var" then true else false) symbols
      in
      { varname = v; vartype = var.vartype }
    else
      raise (Failure ("Unable to find " ^ v ^ " in symbol table"))

let rec string_of_expr symbols = function
    Literal(l) -> string_of_int l
  | Floatlit(l) -> "(float)" ^ string_of_float l (* cast to float..Java's default type is double *)
  | String(s) -> "\"" ^ s ^ "\""
  | Bool(s) -> s
  | Id(s) -> s
  | Uminus(e) -> "-(" ^ string_of_expr symbols e ^ ")"
  | Not(e) -> "!(" ^ string_of_expr symbols e ^ ")"
  | Binop(e1, o, e2) -> (* need to handle special cases here where e1 is an image or kernel type *)
      let e1_decl = type_of_expr symbols e1
      in
      let e2_decl = type_of_expr symbols e2
      in
      if e1_decl.vartype = "image" then (* image type can do +, -, *, /, @ *)
        let op = 
          (match o with
             Add -> "OPERATION.ADD" | Sub -> "OPERATION.SUB" |
             Mult -> "OPERATION.MUL" | Div -> "OPERATION.DIV" |
             Convolve -> "Convolve" |
             Equal | Neq | Less | Leq | Greater | Geq |
             And | Or | Power -> 
               raise (Failure ("The only arithmetic operations allowed for images are +, -, *, /, @")))
        in
        if op = "Convolve" then
          if e2_decl.vartype = "kernel" then
            (***
            "new ConvolveOp(" ^ string_of_expr symbols e2 ^ 
                                ", ConvolveOp.EDGE_NO_OP,null).filter(" ^ 
                                string_of_expr symbols e1 ^ ", null)"
            ***)
            "convolve(" ^ string_of_expr symbols e1 ^ ", " ^
                          string_of_expr symbols e2 ^ ")"
          else
            raise (Failure ("The second operand of '@' must be a kernel type"))
        else
        "(BufferedImage)doArithmetic(" ^ string_of_expr symbols e1 ^ ", " ^ 
                                         string_of_expr symbols e2 ^ ", " ^
                                         op ^ ")"
      else if e1_decl.vartype = "kernel" then
        let op = 
          (match o with
             Add -> "OPERATION.ADD" | Sub -> "OPERATION.SUB" |
             Mult -> "OPERATION.MUL" | Div -> "OPERATION.DIV" |
             Equal | Neq | Less | Leq | Greater | Geq |
             Convolve | And | Or | Power -> 
               raise (Failure ("The only arithmetic operations allowed for kernels are +, -, *, /")))
        in
        "(Kernel)doArithmetic(" ^ string_of_expr symbols e1 ^ ", " ^ 
                                  string_of_expr symbols e2 ^ ", " ^
                                  op ^ ")"
      else
        let op = 
          (match o with
             Power -> "POWER"
           | _ -> "")
        in
        if op = "POWER" then
          if e1_decl.vartype = "int" && e2_decl.vartype = "int" then
            "(int)Math.pow(" ^ string_of_expr symbols e1 ^ ", " ^
                               string_of_expr symbols e2 ^ ")"
          else if e1_decl.vartype = "float" && e2_decl.vartype = "float" then
            "(float)Math.pow(" ^ string_of_expr symbols e1 ^ ", " ^
                                 string_of_expr symbols e2 ^ ")"
          else "" (* walker should block this *)
        else
          string_of_expr symbols e1 ^ " " ^
          (match o with
	     Add -> "+" | Sub -> "-" | Mult -> "*" | Div -> "/"
           | Equal -> "==" | Neq -> "!="
           | Less -> "<" | Leq -> "<=" | Greater -> ">" | Geq -> ">="
           | And -> "&&" | Or -> "||"
           | Power -> "" (* this should never match! *)
           | Convolve -> raise (Failure ("'@' operator can only be used with images and kernels"))) ^ " " ^
           string_of_expr symbols e2  
  (*****    
  | Assign(v, e) -> begin
      match e with
        Id(s) ->
          let lvar = List.find (fun a -> if a.varname = v then true else false) symbols
          in
          let rvar = List.find (fun a -> if a.varname = s then true else false) symbols
          in
          if lvar.vartype = "image" && rvar.vartype = "image" then
            (* clone an image *)
            v ^ " = (BufferedImage)clone(" ^ s ^ ")"
          else if lvar.vartype = "kernel" && rvar.vartype = "kernel" then
            (* clone a kernel *)
            v ^ " = (Kernel)clone(" ^ s ^ ")"
          else
            v ^ " = " ^ string_of_expr symbols e
      | _ -> v ^ " = " ^ string_of_expr symbols e
    end
  *****)
  | Assign(v, e) -> 
      (*let lvalue = List.find (fun a -> if a.varname = v then true else false) symbols in*)
      let lvalue = find_symbol symbols v in
      let rvalue = type_of_expr symbols e in
      if lvalue.vartype = "image" && rvalue.vartype = "image" then
        if rvalue.varname = "imnew" || rvalue.varname = "imread" || rvalue.varname = "togray" then
          v ^ " = " ^ string_of_expr symbols e (* no need to clone if it's a function call *)
        else
        (* clone an image *)
        v ^ " = (BufferedImage)clone(" ^ string_of_expr symbols e ^ ")"
      else if lvalue.vartype = "kernel" && rvalue.vartype = "kernel" then
        if rvalue.varname = "kernelnew" then
          v ^ " = " ^ string_of_expr symbols e (* no need to clone if it's a function call *)
        else
        (* clone a kernel *)
        v ^ " = (Kernel)clone(" ^ string_of_expr symbols e ^ ")"
      else
        v ^ " = " ^ string_of_expr symbols e
      
  | Call(f, el) ->
      let symbols_list = build_list (symbols, List.length el, [])
      in
      (*let ff = List.find (fun a -> if a.varname = f then true else false) symbols
      in
      ff.varname ^ ff.vartype ^ *)
      if f = "mod" then
        let e1 = List.nth el 0 in
        let e2 = List.nth el 1 in
        string_of_expr symbols e1 ^ " % " ^ string_of_expr symbols e2
      else if f = "tostring" then
        let e = List.nth el 0 in
          "String.valueOf(" ^ string_of_expr symbols e ^ ")"
      else if f = "togray" then
        let e = List.nth el 0 in
          "(new ColorConvertOp(ColorSpace.getInstance(ColorSpace.CS_GRAY),null)).filter(" ^
          string_of_expr symbols e ^ ", null)"
      else if f = "sqrt" then
        let e = List.nth el 0 in
        let e_decl = type_of_expr symbols e in
        if e_decl.vartype = "int" then
          "(int)Math.sqrt(" ^ string_of_expr symbols e ^ ")"
        else if e_decl.vartype = "float" then
          "(float)Math.sqrt(" ^ string_of_expr symbols e ^ ")"
        else (* walker should block this *)
          ""
      else
        fcall f ^ "(" ^ String.concat ", " (List.map2 string_of_expr symbols_list el) ^ ")"
  | Datatype(_) -> ""
  | Imnew(e1, e2, s) -> 
      let channel = 
        if s = "rgb" || s = "RGB" then "RGB"
        else if s = "grey" || s = "GREY" || s = "gray" || s = "GRAY" then "GREY"
        else "RGB" (* default image type *)
      in
      "imnew(" ^ string_of_expr symbols e1 ^ ", " ^ 
                 string_of_expr symbols e2 ^ ", " ^
                 "\"" ^ channel ^ "\")"
  (*****
  | ImageAccess(var, e1, e2, s) -> 
      if s = "rgb" || s = "RGB" then
        var ^ ".getRGB(" ^ string_of_expr symbols e1 ^ ", " ^
                           string_of_expr symbols e2 ^ ")"
      else if s = "gray" || s = "grey" || s = "GRAY" || s = "GREY" then
        var ^ ".getSampleModel().getSample(" ^ string_of_expr symbols e1 ^ ", " ^
                                               string_of_expr symbols e2 ^ ", " ^
                                               "0" ^ ", " ^
                                               var ^ ".getRaster().getDataBuffer())"
      else
        var ^ ".getSampleModel().getSample(" ^ string_of_expr symbols e1 ^ ", " ^
                                               string_of_expr symbols e2 ^ ", " ^
                                               channel_num s ^ ", " ^
                                               var ^ ".getRaster().getDataBuffer())"
  *****)
  | ImageAccess(var, e1, e2, e3) ->
      "getImagePixel(" ^ var ^ ", " ^
                         string_of_expr symbols e1 ^ ", " ^
                         string_of_expr symbols e2 ^ ", " ^
                         string_of_expr symbols e3 ^ ")"
  | Kernelnew(e1, e2) ->
      "kernelnew(" ^ string_of_expr symbols e1 ^ ", " ^
                     string_of_expr symbols e2 ^ ")"
  | KernelAccess(k, e1, e2) ->
      "getKernelData(" ^ k ^ ", " ^ 
                         string_of_expr symbols e1 ^ ", " ^
                         string_of_expr symbols e2 ^ ")"
  (*****
  | Convolve(im, k) ->
      "new ConvolveOp(" ^ k ^ ", ConvolveOp.EDGE_NO_OP,null).filter(" ^ im ^ ", null)"
  *****)
  (*****
  | AssignPixel(var, e1, e2, s, value) ->
      if s = "rgb" || s = "RGB" then
        var ^ ".setRGB(" ^ string_of_expr symbols e1 ^ ", " ^
                           string_of_expr symbols e2 ^ ", " ^
                           string_of_expr symbols value ^ ")"
      else if s = "gray" || s = "grey" || s = "GRAY" || s = "GREY" then
        var ^ ".getSampleModel().setSample(" ^ string_of_expr symbols e1 ^ ", " ^
                                               string_of_expr symbols e2 ^ ", " ^
                                               "0" ^ ", " ^
                                               string_of_expr symbols value ^ ", " ^
                                               var ^ ".getRaster().getDataBuffer())"
      else
        var ^ ".getSampleModel().setSample(" ^ string_of_expr symbols e1 ^ ", " ^
                                               string_of_expr symbols e2 ^ ", " ^
                                               channel_num s ^ ", " ^
                                               string_of_expr symbols value ^ ", " ^
                                               var ^ ".getRaster().getDataBuffer())"
  *****)
  | AssignPixel(var, e1, e2, e3, value) ->
      "setImagePixel(" ^ var ^ ", " ^
                         string_of_expr symbols e1 ^ ", " ^
                         string_of_expr symbols e2 ^ ", " ^
                         string_of_expr symbols e3 ^ ", " ^ 
                         string_of_expr symbols value ^ ")"
  | AssignKernel(var, e1, e2, value) ->
      var ^ " = setKernelData(" ^ var ^ ", " ^
                                  string_of_expr symbols e1 ^ ", " ^
                                  string_of_expr symbols e2 ^ ", " ^
                                  string_of_expr symbols value ^ ")"
      
(* convert 2D matrix to 1D matrix for kernel *)
(* e.g. 3x3 to 1x9 *)
let rec expand_kernel_list a l =
  let lr = List.rev l
  in a @ lr

(*let rec string_of_stmt retname = function*)
let rec string_of_stmt symbols = function
    Block(stmts) ->
      (*let retname_list = build_list (retname, List.length stmts, [])*)
      let symbols_list = build_list (symbols, List.length stmts, [])
      in
      (*"{\n" ^ String.concat "" (List.map2 string_of_stmt retname_list stmts) ^ "}\n"*)
      "{\n" ^ String.concat "" (List.map2 string_of_stmt symbols_list stmts) ^ "}\n"
  | Expr(expr) -> begin
      match expr with
        (* we ignore stmts that don't have lvalue to store the result of an expr *)
        Literal(_) | Floatlit(_) | String(_) | Id(_) | Uminus(_) | Binop(_, _, _) -> ""
      | _ -> string_of_expr symbols expr ^ ";\n";
    end 
  | If(e, s, Block([])) -> "if (" ^ string_of_expr symbols e ^ ")\n" ^ string_of_stmt symbols s
  | If(e, s1, s2) ->  "if (" ^ string_of_expr symbols e ^ ")\n" ^
      string_of_stmt symbols s1 ^ "else\n" ^ string_of_stmt symbols s2
  | Ifelseif(e, s, eif_list, Block([])) -> 
      let rec print_elseif eif =
        "else if(" ^ string_of_expr symbols eif.elseif_expr ^ ")\n" ^
        string_of_stmt symbols eif.elseif_stmt
      in
      "if (" ^ string_of_expr symbols e ^ ")\n" ^ string_of_stmt symbols s ^
      String.concat "" (List.map print_elseif eif_list)
  | Ifelseif(e, s1, eif_list, s2) -> 
      let rec print_elseif eif =
        "else if(" ^ string_of_expr symbols eif.elseif_expr ^ ")\n" ^
        string_of_stmt symbols eif.elseif_stmt
      in
      "if (" ^ string_of_expr symbols e ^ ")\n" ^ string_of_stmt symbols s1 ^
      (String.concat "" (List.map print_elseif eif_list)) ^ "else\n" ^ string_of_stmt symbols s2
  | For(Assigna(v, e1, e2), s) ->
      "for (" ^ v ^ " = " ^ string_of_expr symbols e1 ^ " ; " ^ v ^ " <= " ^ string_of_expr symbols e2 ^ " ; " ^ 
      v ^ "++)" ^ string_of_stmt symbols s
  | For(Assignb(v, e1, e2, e3), s) -> begin
      match e2 with
        Literal(l) ->
          if l = 0 then
            raise (Failure ("increment value cannot be zero"))
          else
            "for (" ^ v ^ " = " ^ string_of_expr symbols e1 ^ " ; " ^ v ^ " <= " ^ string_of_expr symbols e3 ^ " ; " ^
            v ^ " += " ^ string_of_expr symbols e2 ^ ")" ^ string_of_stmt symbols s
      | Floatlit(l) ->
          if l = 0.0 then
            raise (Failure ("increment value cannot be zero"))
          else
            "for (" ^ v ^ " = " ^ string_of_expr symbols e1 ^ " ; " ^ v ^ " <= " ^ string_of_expr symbols e3 ^ " ; " ^
            v ^ " += " ^ string_of_expr symbols e2 ^ ")" ^ string_of_stmt symbols s
      | Uminus(Literal(l)) ->
          if l = 0 then
            raise (Failure ("increment value cannot be zero"))
          else
            "for (" ^ v ^ " = " ^ string_of_expr symbols e1 ^ " ; " ^ v ^ " >= " ^ string_of_expr symbols e3 ^ " ; " ^
            v ^ " += " ^ string_of_expr symbols e2 ^ ")" ^ string_of_stmt symbols s
      | Uminus(Floatlit(l)) -> 
          if l = 0.0 then
            raise (Failure ("increment value cannot be zero"))
          else
            "for (" ^ v ^ " = " ^ string_of_expr symbols e1 ^ " ; " ^ v ^ " >= " ^ string_of_expr symbols e3 ^ " ; " ^
            v ^ " += " ^ string_of_expr symbols e2 ^ ")" ^ string_of_stmt symbols s
      | _ -> raise (Failure ("increment value must be an integer or float literal: " ^ string_of_expr symbols e2))
    end
  | While(e, s) -> "while (" ^ string_of_expr symbols e ^ ") " ^ string_of_stmt symbols s
  | KernelInit(k, l) -> 
      let elist = List.fold_left expand_kernel_list [] l
      in
      let symbols_list = build_list (symbols, List.length elist, [])
      in
      let slist = List.map2 string_of_expr symbols_list elist
      in
      let x = string_of_int (List.hd (List.map (fun subl -> List.length subl) l))
      in
      let y = string_of_int (List.length l)
      in
      k ^ " = new Kernel (" ^ x ^ ", "
                            ^ y ^ ", new float[]{" ^
                           (String.concat ", " slist) ^ "});\n"

let string_of_vdecl var = java_type_of var.vartype ^ " " ^ var.varname ^ " = " ^
  initial_value var.vartype ^ ";\n"

let string_of_global_vdecl var =
  "public static " ^ java_type_of var.vartype ^ " " ^ var.varname ^ " = " ^ 
  initial_value var.vartype ^ ";\n"

(* declare return variable *)
let retvar_decl fdecl = 
  if fdecl.rettype = "void" then ""
  else java_type_of fdecl.rettype ^ " " ^ fdecl.retname ^ " = " ^ 
  initial_value fdecl.rettype ^ ";\n"

(* return retname *)
let retvar_return fdecl =
  if fdecl.rettype = "void" then ""
  else "return " ^ fdecl.retname ^ ";\n"

let string_of_fdecl fdecl globals =
  (* let retname_list = build_list (fdecl.retname, List.length fdecl.body, []) *)
  let symbols = globals @ fdecl.locals @ fdecl.formals @ [{ varname = fdecl.retname; vartype = fdecl.rettype}]
  in
  let symbols_list = build_list (symbols, List.length fdecl.body, [])
  in
  fsignature fdecl ^ "\n{\n" ^
  retvar_decl fdecl ^
  String.concat "" (List.map string_of_vdecl fdecl.locals) ^
  (* String.concat "" (List.map2 string_of_stmt retname_list fdecl.body) ^ *)
  String.concat "" (List.map2 string_of_stmt symbols_list fdecl.body) ^
  retvar_return fdecl ^
  "}\n"

(*
let rec merge_vars_funcs vars funcs =
  if List.length funcs = 0 then vars
  else
    let func = List.hd funcs
    in 
    { varname = func.fname; vartype = func.rettype } :: merge_vars_funcs vars (List.tl funcs)
*)

let string_of_program (vars, funcs) =
  (* let globals = merge_vars_funcs vars funcs *)
  let global_funcs = List.map (fun a -> { varname = a.fname ^ "_global_func"; vartype = a.rettype }) funcs
  in
  let global_vars = List.map (fun a -> { varname = a.varname ^ "_global_var"; vartype = a.vartype }) vars
  in
  let globals = global_funcs @ global_vars (* concatenate global variables and global functions to form symbols *)
  in
  let globals_list = build_list (globals, List.length funcs, [])
  in
  import_decl ^ class_decl ^
  String.concat "" (List.map string_of_global_vdecl vars) ^ "\n" ^
  String.concat "\n" (List.map2 string_of_fdecl funcs globals_list) ^ "\n}\n" ^
  "\n" ^ imgrender_decl
